**************************************************
*-- Author:       Michael Drozdov
*-- Description:  Demonstrate:
*--               VFPCom.ComUtil for convert VFP-cursor to AdoRecordset 
*--				  using OLE control from code
*--				  ... and MS DataGrid control
*-- Used:         MSDATGRD.OCX (MS DataGrid),
*--               vfpcom.dll (VFPCom.ComUtil) see VFPCOM Utility on http://msdn.microsoft.com/vfoxpro/downloads/updates.asp ,
*--               msado21.tlb (ADODB.Recordset)
*--               Employee.dbf from D:\Program Files\Microsoft Visual Studio\MSDN\99OCT\1033\SAMPLES\VFP98\data\Testdata.dbc
*-- Time Stamp:   09/19/00 04:25:12 PM
**************************************************

#DEFINE C_DBCNAME				"Testdata"
#DEFINE C_TABLENAME				"Employee"
#DEFINE C_VFPCOMCLASS			"VFPCom.ComUtil"
#DEFINE C_ADORSPROGID			"ADODB.Recordset"

RELEASE oFrm
PUBLIC oFrm
oFrm = CreateObject("frmToAdoRecordset")
IF VARTYPE(oFrm) # 'O'
	RELEASE oFrm
	RETURN .F.
ENDIF
oFrm.Show()	

**************************************************
*-- Form:         frmToAdoRecordset 
*-- ParentClass:  form
*-- BaseClass:    form
*-- Time Stamp:   09/19/00 04:25:12 PM
*
DEFINE CLASS frmToAdoRecordset AS form

	DataSession = 2
	DoCreate = .T.
	AutoCenter = .T.
	Caption = "Convert VFP-cursor to Ado Recordset"
	Name = "frmToAdoRecordset"
	oadorecordset = .F.


	ADD OBJECT olecontrol1 AS olecontrol WITH ;
		Top = 12, ;
		Left = 12, ;
		Height = 229, ;
		Width = 349, ;
		Name = "Olecontrol1", ;
		OleClass = 'MSDataGridLib.DataGrid.1'

	PROCEDURE Init
		ThisForm.Resize()
	ENDPROC


	PROCEDURE Resize
		WITH ThisForm.Olecontrol1
			LOCAL lnWs, lnHs
			lnWs = .Left+.Left
			lnHs = .Top+.Top
			IF ThisForm.Width > lnWs
				.Width = ThisForm.Width - lnWs
			ENDIF
			IF 	ThisForm.Height > lnHs
				.Height = ThisForm.Height - lnHs
			ENDIF
		ENDWITH
	ENDPROC


	PROCEDURE Load
		*
		*-- Open VFP-table
		IF ThisForm.DataSession <> 1
			SET DATASESSION TO ThisForm.DataSessionID
			SET DELETED ON
			SET MULTILOCKS ON
			SET EXCLUSIVE OFF
		ENDIF
		LOCAL lbIsDbc, llIsError
		lbIsDbc = DBUSED(C_DBCNAME)
		IF USED(C_TABLENAME)
			SELECT (C_TABLENAME)
		ELSE
			SELECT 0
			USE (LOCFILE(HOME(2)+"data\"+C_TABLENAME+".dbf","DBF","Where is "+C_TABLENAME+"?"));
				AGAIN ALIAS (C_TABLENAME) SHARED 
		ENDIF
		IF !USED(C_TABLENAME)
			ACTIVATE SCREEN
			?CHR(7)
			MESSAGEBOX("Can not open table: "+C_TABLENAME, 16, ThisForm.Caption)
			llIsError = .T.
		ENDIF

		*
		*-- Create VfpCom object
		LOCAL loVfpCom
		IF !llIsError
			loVfpCom = NEWOBJECT(C_VFPCOMCLASS)
			IF VARTYPE(loVfpCom) # 'O'
				ACTIVATE SCREEN
				?CHR(7)
				MESSAGEBOX("Can not create object: "+C_VFPCOMCLASS, 16, ThisForm.Caption)
				llIsError = .T.
			ENDIF
		ENDIF

		*
		*-- Create AdoRecordset object
		LOCAL lnError
		IF !llIsError
			WITH ThisForm
				.oAdoRecordset = NEWOBJECT(C_ADORSPROGID)
				IF VARTYPE(.oAdoRecordset) # 'O'
					ACTIVATE SCREEN
					?CHR(7)
					MESSAGEBOX("Can not create object: "+C_ADORSPROGID, 16, .Caption)
					llIsError = .T.
				ELSE
					*
					*-- Convert VFP-cursor to AdoREcordset
					lnError = loVfpCom.CursorToRS(.oAdoRecordset, C_TABLENAME)
					IF lnError # 0
						ACTIVATE SCREEN
						?CHR(7)
						MESSAGEBOX("Can not convert VFP-cursor to AdoREcordset. Error: "+LTRIM(STR(lnError)), 16, .Caption)
						llIsError = .T.
					ENDIF
				ENDIF
			ENDWITH
		ENDIF
		*
		*-- Close data
		IF USED(C_TABLENAME)
			USE IN (C_TABLENAME)
		ENDIF
		IF !lbIsDbc AND DBUSED(C_DBCNAME)
			SET DATABASE TO (C_DBCNAME)
			CLOSE DATABASE
		ENDIF
		RETURN !llIsError
	ENDPROC


	PROCEDURE olecontrol1.Init
		LOCAL loRS
		loRS = ThisForm.oAdoRecordset
		IF VARTYPE(loRS) # 'O'
			RETURN
		ENDIF
		With This.Object
		    .DataSource = loRS
		    *
		    *-- Check data in recordset
		    If !loRS.BOF AND !loRS.EOF Then
				loRS.MoveFirst()
	            .ReBind
		    EndIf
		EndWith
	ENDPROC


ENDDEFINE
*
*-- EndDefine: frmtoadorecordset
**************************************************
